## qemu-web-desktop 26.01.08+ds1

=== src/Makefile ===
# Makefile to install qemu-web-desktop.
# just type: make install
#
# required:
#   apache2 libapache2-mod-perl2 novnc websockify qemu-kvm bridge-utils qemu
#   iptables dnsmasq libcgi-pm-perl liblist-moreutils-perl libsys-cpu-perl
#   libsys-cpuload-perl libsys-meminfo-perl libnet-dns-perl confget
#   libproc-background-perl libproc-processtable-perl libemail-valid-perl 
#   libnet-smtps-perl libmail-imapclient-perl libnet-ldap-perl 
#   libemail-valid-perl libjson-perl libwww-perl libguestfs-tools libapache2-mpm-itk
#   libtext-qrcode-perl
# on ARM64, an EFI boot is required (e.g. qemu-efi-aarch64)
#
# NOTES:
#   you may have to tune the path to /etc/apache2/conf-available/serve-cgi-bin.conf
#   or other locations. The current makefile works best on Debian-class systems.
#
# make install
#   install   qemu-web-desktop
# make config
#   configure qemu-web-desktop
# make deps
#   install dependencies (before make install)
# make test
#   test
# make deb
#   build debian package
# make help
#   build the documentation files (requires help2man pandoc librsvg2-bin texlive-latex-base  	texlive-latex-recommended)

# alt man generation: pandoc -s -o qwdctl.1 --to man -f markdown-smart qwdctl.md

ARCH=

# auto detect system type
ifneq ("$(wildcard /etc/debian_version)","")
  ARCH = Debian
  $(info Detected Debian-type system)
else ifneq ("$(wildcard /etc/redhat-release)","")
  ARCH = RedHat
  $(info Detected RedHat-type system)
else ifneq ("$(wildcard /etc/arch-release)","")
  ARCH = Arch
  $(info Detected Arch-type system)
else ifneq ("$(wildcard /etc/bashrc_Apple_Terminal)","")
  ARCH = Darwin
  $(info Detected Darwin-type system - Apple)
endif

# auto detect type of CPU (for installation)
uname_m := $(shell uname -m)
QEMU.i386    := qemu-system-x86
QEMU.x86_64  := qemu-system-x86
QEMU.aarch64 := qemu-system-arm
QEMU.arm64   := qemu-system-arm

QEMU ?= $(QEMU.$(uname_m))

ifeq ($(ARCH),Debian)
  DIR_CGI_BIN         = /usr/lib/cgi-bin
  DIR_APACHE_CONF_QWD = /etc/apache2/conf-available
  APACHE_CONF         =
  DIR_WWW             = /var/www/html
else ifeq ($(ARCH),RedHat)
  DIR_CGI_BIN         = /var/www/cgi-bin
  DIR_APACHE_CONF_QWD = /etc/httpd/conf.d/
  APACHE_CONF         = /etc/httpd/conf/httpd.conf
  DIR_WWW             = /var/www/html
else ifeq ($(ARCH),Arch)
  DIR_CGI_BIN         = /srv/http/cgi-bin
  DIR_APACHE_CONF_QWD = /etc/httpd/conf/extra/
  APACHE_CONF         = /etc/httpd/conf/httpd.conf
  DIR_WWW             = /srv/http
else ifeq ($(ARCH),Darwin)
  DESTDIR            ?= $(shell brew --prefix)
  PERLDIR             = $(shell brew --prefix perl)
  DIR_CGI_BIN         = /var/www/cgi-bin
  DIR_APACHE_CONF_QWD = /etc/httpd/extra/
  APACHE_CONF         = /etc/httpd/httpd.conf
  DIR_WWW             = /var/www
else
  $(error Undefined target. Set system type with: make install ARCH=Debian|RedHat|Arch)
endif

all:

help:
	@help2man -o qwdctl.1 --no-discard-stderr -n 'control qemu-web-desktop' bin/qwdctl || true
	@pandoc ../README.md --to pdf > README.pdf || echo "WARNING: skip pdf doc (missing pandoc)"
	@echo "Usage: install qemu-web-desktop"
	@echo "make deps"
	@echo "  install dependencies"
	@echo "make install"
	@echo "  install qemu-web-desktop"
	@echo "make deb"
	@echo "  create debian package"

# ------------------------------------------------------------------------------
# dependencies

deps:
	@echo "Installing $(ARCH)-class dependencies"
ifeq ($(ARCH),Debian)
	sudo apt install apache2 libapache2-mod-perl2 novnc websockify $(QEMU) qemu-utils bridge-utils iptables dnsmasq libcgi-pm-perl liblist-moreutils-perl libsys-cpu-perl libsys-cpuload-perl libsys-meminfo-perl libnet-dns-perl confget libproc-background-perl libproc-processtable-perl libemail-valid-perl  libnet-smtps-perl libmail-imapclient-perl libnet-ldap-perl libemail-valid-perl libjson-perl libwww-perl libguestfs-tools libapache2-mpm-itk libtext-qrcode-perl libnet-ssh2-perl
	if [ "$(uname_m)" = "aarch64" -o "$(uname_m)" = "arm64" ]; then sudo apt install qemu-efi-aarch64; fi
else ifeq ($(ARCH),Arch)
	@echo "NOTE: You need 'yay' to be installed, and the AUR to be available."
	yay -Sy python-numpy python-setuptools mod_itk apache qemu-desktop bridge-utils qemu-img dnsmasq guestfs-tools perl-cgi perl-list-moreutils perl-sys-cpu perl-sys-meminfo perl-net-dns perl-proc-processtable perl-mail-imapclient perl-ldap perl-json perl-libwww mod_perl novnc websockify perl-proc-background perl-email-valid perl-net-smtps perl-text-qrcode perl-net-ssh2 confget
else ifeq ($(ARCH),RedHat)
	@echo "NOTE: This system-type is not fully supported"
	sudo dnf install mod_perl novnc python3-websockify crudini guestfs-tools perl-CGI perl-List-MoreUtils perl-Sys-CPU perl-Sys-MemInfo perl-Net-DNS perl-Proc-ProcessTable perl-Email-Valid perl-Net-SMTPS perl-Mail-IMAPClient perl-LDAP perl-JSON perl-libwww-perl perl-Text-QRCode perl-Net-SSH2 perl-Net-Ping perl-CPAN
	sudo cpan Proc::Background
else ifeq ($(ARCH),Darwin)
	@echo "NOTE: This system-type is not properly supported"
	brew install apache2 qemu perl python3 python-setuptools grep wget gnu-sed nano
	# install PERL CPAN modules
	# WARNING: Net::SMTPS fails installation on Mac
	PERL_MM_OPT="INSTALL_BASE=$(PERLDIR)/lib/perl5/site_perl" cpan CGI Cwd File::Temp File::Path File::Basename File::Copy List::MoreUtils
	PERL_MM_OPT="INSTALL_BASE=$(PERLDIR)/lib/perl5/site_perl" cpan List::Util IO::Socket::INET IO::Socket::IP JSON Proc::Background
	PERL_MM_OPT="INSTALL_BASE=$(PERLDIR)/lib/perl5/site_perl" cpan Proc::ProcessTable Proc::Killfam System::CPU Sys::MemInfo Email::Valid
	PERL_MM_OPT="INSTALL_BASE=$(PERLDIR)/lib/perl5/site_perl" cpan Mail::IMAPClient LWP::UserAgent Net::Ping Net::LDAP Net::SSH2 URI
	# install websockify
	$(cd /tmp; wget https://github.com/novnc/websockify/archive/refs/tags/v0.13.0.tar.gz; tar xzf v0.13.0.tar.gz; cd websockify-0.13.0; python3 setup.py build; python3 setup.py build; )
	# install novnc
	if [ ! -d "$(DESTDIR)/share/novnc" ]; then bash -c "cd /tmp; wget https://github.com/novnc/noVNC/archive/refs/tags/v1.6.0.tar.gz; tar xzf v1.6.0.tar.gz; cp -r noVNC-1.6.0 $(DESTDIR)/share/novnc"; fi
endif
	@echo "[OK] Dependencies installed for $(ARCH)"
	@echo "You may now proceed with: make install"

# ------------------------------------------------------------------------------
# install

install: copy config

copy:
	@echo "Installing QWD files for $(ARCH)-type system"
ifeq ($(ARCH),Darwin)
	# create directories (install command is broken - we use mkdir/cp)
	mkdir -p                            $(DESTDIR)$(prefix)/etc/qemu-web-desktop
	mkdir -p                            $(DESTDIR)$(prefix)/etc/qemu-web-desktop/config.d
	mkdir -p                            $(DESTDIR)$(prefix)/bin
	mkdir -p                            $(DESTDIR)$(prefix)/usr/share/qemu-web-desktop/html/desktop
	mkdir -p                            $(DESTDIR)$(prefix)/usr/share/qemu-web-desktop/html/desktop/images
	mkdir -p                            $(DESTDIR)$(prefix)/usr/share/doc/qemu-web-desktop
	mkdir -p                            $(DESTDIR)$(prefix)/var/lib/qemu-web-desktop/machines
	mkdir -p                            $(DESTDIR)$(prefix)/var/lib/qemu-web-desktop/snapshots
	# common install
	cp         machines.conf            $(DESTDIR)$(prefix)/etc/qemu-web-desktop/
	cp         config.pl                $(DESTDIR)$(prefix)/etc/qemu-web-desktop/
	cp         html/desktop/index.html  $(DESTDIR)$(prefix)/usr/share/qemu-web-desktop/html/desktop
	cp         html/desktop/style.css   $(DESTDIR)$(prefix)/usr/share/qemu-web-desktop/html/desktop
	cp         html/desktop/images/*    $(DESTDIR)$(prefix)/usr/share/qemu-web-desktop/html/desktop/images
	# cp         qwdctl.1                 $(DESTDIR)$(prefix)/usr/share/man/man1/qwdctl.1
	cp         README.pdf               $(DESTDIR)$(prefix)/usr/share/doc/qemu-web-desktop
	cp         bin/qwdctl               $(DESTDIR)$(prefix)/bin/
	cp         html/desktop/machines/*  $(DESTDIR)$(prefix)/var/lib/qemu-web-desktop/machines
	# system specific locations
	mkdir -p                            $(DESTDIR)$(prefix)$(DIR_WWW)
	# mkdir -p                            $(DESTDIR)$(prefix)$(DIR_APACHE_CONF_QWD)
	# cp apache.conf                      $(DESTDIR)$(prefix)$(DIR_APACHE_CONF_QWD)/qemu-web-desktop.conf
	mkdir -p                            $(DESTDIR)$(prefix)$(DIR_CGI_BIN)
	cp cgi-bin/qemu-web-desktop.pl      $(DESTDIR)$(prefix)$(DIR_CGI_BIN)/qemu-web-desktop.pl
else
	# create directories
	install -D -d                       $(DESTDIR)$(prefix)/etc/qemu-web-desktop
	install -D -d                       $(DESTDIR)$(prefix)/usr/bin
	install -D -d                       $(DESTDIR)$(prefix)/usr/share/qemu-web-desktop/html/desktop
	install -D -d                       $(DESTDIR)$(prefix)/usr/share/qemu-web-desktop/html/desktop/images
	install -D -d                       $(DESTDIR)$(prefix)/usr/share/doc/qemu-web-desktop
	install -D -d                       $(DESTDIR)$(prefix)/var/lib/qemu-web-desktop/machines
	install -D -d                       $(DESTDIR)$(prefix)/var/lib/qemu-web-desktop/snapshots
	# common install
	install -D machines.conf            $(DESTDIR)$(prefix)/etc/qemu-web-desktop/
	install -D config.pl                $(DESTDIR)$(prefix)/etc/qemu-web-desktop/
	install -D html/desktop/index.html  $(DESTDIR)$(prefix)/usr/share/qemu-web-desktop/html/desktop
	install -D html/desktop/style.css   $(DESTDIR)$(prefix)/usr/share/qemu-web-desktop/html/desktop
	install -D html/desktop/images/*    $(DESTDIR)$(prefix)/usr/share/qemu-web-desktop/html/desktop/images
	install -D qwdctl.1                 $(DESTDIR)$(prefix)/usr/share/man/man1/qwdctl.1
	install -D README.pdf               $(DESTDIR)$(prefix)/usr/share/doc/qemu-web-desktop
	install -D bin/qwdctl               $(DESTDIR)$(prefix)/usr/bin/
	install -D html/desktop/machines/*  $(DESTDIR)$(prefix)/var/lib/qemu-web-desktop/machines
	# system specific locations
	install -D -d                          $(DESTDIR)$(prefix)$(DIR_WWW)
	install -D -d                          $(DESTDIR)$(prefix)$(DIR_APACHE_CONF_QWD)
	install apache.conf                    $(DESTDIR)$(prefix)$(DIR_APACHE_CONF_QWD)/qemu-web-desktop.conf
	install -D -d                          $(DESTDIR)$(prefix)$(DIR_CGI_BIN)
	install -D cgi-bin/qemu-web-desktop.pl $(DESTDIR)$(prefix)$(DIR_CGI_BIN)/qemu-web-desktop.pl
	# system specific actions
ifneq ($(ARCH),Debian)
	sed -i 's|Alias /qemu-web-desktop|#Alias /qemu-web-desktop|'  $(DESTDIR)$(prefix)$(DIR_APACHE_CONF_QWD)/qemu-web-desktop.conf
	sed -i 's/config{service_port_multiple}    = 0/config{service_port_multiple}    = 1/' $(DESTDIR)$(prefix)/etc/qemu-web-desktop//config.pl
	sed -i 's/machines_insert=no/machines_insert=yes/'            $(DESTDIR)$(prefix)/usr/bin/qwdctl
endif
endif
	-mv $(DESTDIR)$(prefix)/usr/share/qemu-web-desktop/html/desktop/machines/* $(DESTDIR)$(prefix)/var/lib/qemu-web-desktop/machines/
	chmod a+wxr                         $(DESTDIR)$(prefix)/var/lib/qemu-web-desktop
	chmod a+xrw                         $(DESTDIR)$(prefix)/var/lib/qemu-web-desktop/machines
	chmod u+xrw                         $(DESTDIR)$(prefix)/var/lib/qemu-web-desktop/snapshots
	find                                $(DESTDIR)$(prefix)/usr/share/qemu-web-desktop/html -type f -exec chmod a+r {} +
	find                                $(DESTDIR)$(prefix)/usr/share/qemu-web-desktop/html -type d -exec chmod a+rx {} +
	chmod 755                           $(DESTDIR)$(prefix)$(DIR_CGI_BIN)/qemu-web-desktop.pl
	@echo "[OK] QWD Installation complete for $(ARCH)."
	@echo "You may now proceed with: make config"

# ------------------------------------------------------------------------------
# post-install/auto configure

config:
	@echo "Post QWD installation steps (auto-configure) for $(ARCH)"
	ln -sf $(DESTDIR)$(prefix)/usr/share/qemu-web-desktop/html/desktop  $(DESTDIR)$(prefix)$(DIR_WWW)/
	ln -sf $(DESTDIR)$(prefix)/var/lib/qemu-web-desktop/machines        $(DESTDIR)$(prefix)$(DIR_WWW)/desktop/
ifeq ($(ARCH),Debian)

=== debian/changelog ===
qemu-web-desktop (26.01.08+ds1-1) unstable; urgency=medium

  [ Emmanuel FARHI ]
  * New upstream version 26.01.08+ds1

  [ Picca Frédéric-Emmanuel ]
  Bump debhelper from old 12 to 13.
  Set debhelper-compat version in Build-Depends.
  d/salsa-ci.yml: Added and de-activated i386 build.

 -- Picca Frédéric-Emmanuel <picca@debian.org>  Sun, 11 Jan 2026 13:35:02 +0100

=== debian/control ===
Source: qemu-web-desktop
Section: science
Priority: optional
Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Roland Mas <lolando@debian.org>, Emmanuel Farhi <emmanuel.farhi.1@gmail.com>, Frédéric-Emmanuel Picca <picca@debian.org>
Build-Depends: debhelper-compat (= 13), dh-apache2, pandoc
Standards-Version: 4.1.2
Vcs-Browser: https://salsa.debian.org/debian/qemu-web-desktop
Vcs-Git: https://salsa.debian.org/debian/qemu-web-desktop.git
Homepage: https://gitlab.com/soleil-data-treatment/soleil-software-projects/remote-desktop

Package: qemu-web-desktop
Architecture: amd64 ppc64el arm64 riscv64 loong64
Depends: ${shlibs:Depends}, ${misc:Depends},
  apache2,
  libapache2-mod-perl2,
  libapache2-mpm-itk,
  websockify,
  qemu-system-x86 [amd64],
  qemu-system-arm [arm64],
  qemu-system-ppc [ppc64el],
  qemu-system-misc [loong64],
  bridge-utils,
  iptables,
  dnsmasq,
  guestfs-tools,
  libcgi-pm-perl,
  libemail-valid-perl,
  libjson-perl,
  liblist-moreutils-perl,
  libmail-imapclient-perl,
  libnet-dns-perl,
  libnet-ldap-perl,
  libnet-smtps-perl,
  libnet-ssh2-perl,
  libproc-background-perl,
  libproc-processtable-perl,
  libsys-cpuload-perl,
  libsys-cpu-perl,
  libsys-meminfo-perl,
  libtext-qrcode-perl,
  novnc,
  confget,
  adduser
Recommends: ${misc:Recommends}
Suggests: qemu-system
Description: Remote desktop service with virtual machines in a browser (DARTS).
 A remote desktop service that launches virtual machines and displays
 them in your browser. Place virtual machine files (ISO, QCOW2, VDI,
 VMDK...) into /var/lib/qemu-web-desktop/machines, add their name in
 the /etc/qemu-web-desktop/machines.conf file, and run qwdctl
 refresh. You can tune the service settings in the
 /etc/qemu-web-desktop/config.pl
 This project is also named Data Analysis Remote Treatment Service (DARTS).
 .
 Once installed, connect to http://server/qemu-web-desktop

## qemu-web-desktop 26.02.08%2Bds1

=== Makefile ===
# Makefile to install qemu-web-desktop.
# just type: make install
#
# required:
#   apache2 libapache2-mod-perl2 novnc websockify qemu-kvm bridge-utils qemu
#   iptables dnsmasq libcgi-pm-perl liblist-moreutils-perl libsys-cpu-perl
#   libsys-cpuload-perl libsys-meminfo-perl libnet-dns-perl confget
#   libproc-background-perl libproc-processtable-perl libemail-valid-perl 
#   libnet-smtps-perl libmail-imapclient-perl libnet-ldap-perl 
#   libemail-valid-perl libjson-perl libwww-perl libguestfs-tools libapache2-mpm-itk
#   libtext-qrcode-perl
# on ARM64, an EFI boot is required (e.g. qemu-efi-aarch64)
#
# NOTES:
#   you may have to tune the path to /etc/apache2/conf-available/serve-cgi-bin.conf
#   or other locations. The current makefile works best on Debian-class systems.
#
# make install
#   install   qemu-web-desktop
# make config
#   configure qemu-web-desktop
# make deps
#   install dependencies (before make install)
# make test
#   test
# make deb
#   build debian package
# make help
#   build the documentation files (requires help2man pandoc librsvg2-bin texlive-latex-base  	texlive-latex-recommended)

# alt man generation: pandoc -s -o qwdctl.1 --to man -f markdown-smart qwdctl.md

ARCH=

VERSION=$(shell awk -F= '/config{version}[[:space:]]*=/ {print $$2}' cgi-bin/qemu-web-desktop.pl | sed -e 's/;.*//' -e 's/"//g' -e 's/[[:space:]]*//g' | tail -1 )

# auto detect system type
ifneq ("$(wildcard /etc/debian_version)","")
  ARCH = Debian
  $(info Detected Debian-type system)
else ifneq ("$(wildcard /etc/redhat-release)","")
  ARCH = RedHat
  $(info Detected RedHat-type system)
else ifneq ("$(wildcard /etc/arch-release)","")
  ARCH = Arch
  $(info Detected Arch-type system)
else ifneq ("$(wildcard /etc/bashrc_Apple_Terminal)","")
  ARCH = Darwin
  $(info Detected Darwin-type system - Apple)
endif

# auto detect type of CPU (for installation)
uname_m := $(shell uname -m)
QEMU.i386    := qemu-system-x86
QEMU.x86_64  := qemu-system-x86
QEMU.aarch64 := qemu-system-arm
QEMU.arm64   := qemu-system-arm

QEMU ?= $(QEMU.$(uname_m))

ifeq ($(ARCH),Debian)
  DIR_CGI_BIN         = /usr/lib/cgi-bin
  DIR_APACHE_CONF_QWD = /etc/apache2/conf-available
  APACHE_CONF         =
  DIR_WWW             = /var/www/html
else ifeq ($(ARCH),RedHat)
  DIR_CGI_BIN         = /var/www/cgi-bin
  DIR_APACHE_CONF_QWD = /etc/httpd/conf.d/
  APACHE_CONF         = /etc/httpd/conf/httpd.conf
  DIR_WWW             = /var/www/html
else ifeq ($(ARCH),Arch)
  DIR_CGI_BIN         = /srv/http/cgi-bin
  DIR_APACHE_CONF_QWD = /etc/httpd/conf/extra/
  APACHE_CONF         = /etc/httpd/conf/httpd.conf
  DIR_WWW             = /srv/http
else ifeq ($(ARCH),Darwin)
  DESTDIR            ?= $(shell brew --prefix)
  PERLDIR             = $(shell brew --prefix perl)
  DIR_CGI_BIN         = /var/www/cgi-bin
  DIR_APACHE_CONF_QWD = /etc/httpd/extra/
  APACHE_CONF         = /etc/httpd/httpd.conf
  DIR_WWW             = /var/www
else
  $(error Undefined target. Set system type with: make install ARCH=Debian|RedHat|Arch)
endif

all:

help:
	@help2man -o doc/qwdctl.1 --no-discard-stderr -n 'control qemu-web-desktop' bin/qwdctl || true
	@pandoc -s -f man -t markdown < doc/qwdctl.1 > doc/qwdctl.md || true
	@sed '/^\[!\[DOI\]/d' README.md | pandoc --to pdf -o doc/README.pdf || true
	@pandoc --to pdf -o doc/CONFIGURE.pdf doc/CONFIGURE.md || true
	@pandoc --to pdf -o doc/INSTALL.pdf   doc/INSTALL.md   || true
	@pandoc --to pdf -o doc/GPU.pdf       doc/GPU.md       || true
	@pandoc --to pdf -o doc/VIRTUAL_MACHINES.pdf doc/VIRTUAL_MACHINES.md  || true
	@echo "Usage: install qemu-web-desktop"
	@echo "make deps"
	@echo "  install dependencies"
	@echo "make install"
	@echo "  install qemu-web-desktop"
	@echo "make uninstall"
	@echo "  uninstall qemu-web-desktop"
	@echo "make deb"
	@echo "  create debian package"

# ------------------------------------------------------------------------------
# dependencies

deps:
	@echo "Installing $(ARCH)-class dependencies"
ifeq ($(ARCH),Debian)
	sudo apt install apache2 libapache2-mod-perl2 novnc websockify $(QEMU) qemu-utils bridge-utils iptables dnsmasq libcgi-pm-perl liblist-moreutils-perl libsys-cpu-perl libsys-cpuload-perl libsys-meminfo-perl libnet-dns-perl confget libproc-background-perl libproc-processtable-perl libemail-valid-perl  libnet-smtps-perl libmail-imapclient-perl libnet-ldap-perl libemail-valid-perl libjson-perl libwww-perl libguestfs-tools libapache2-mpm-itk libtext-qrcode-perl libnet-ssh2-perl wget
	if [ "$(uname_m)" = "aarch64" -o "$(uname_m)" = "arm64" ]; then sudo apt install qemu-efi-aarch64; fi
else ifeq ($(ARCH),Arch)
	@echo "NOTE: You need 'yay' to be installed, and the AUR to be available."
	yay -Sy python-numpy python-setuptools mod_itk apache qemu-desktop bridge-utils qemu-img dnsmasq guestfs-tools perl-cgi perl-list-moreutils perl-sys-cpu perl-sys-meminfo perl-net-dns perl-proc-processtable perl-mail-imapclient perl-ldap perl-json perl-libwww mod_perl novnc websockify perl-proc-background perl-email-valid perl-net-smtps perl-text-qrcode perl-net-ssh2 confget wget
else ifeq ($(ARCH),RedHat)
	@echo "NOTE: This system-type is not fully supported"
	sudo dnf install mod_perl novnc python3-websockify crudini guestfs-tools perl-CGI perl-List-MoreUtils perl-Sys-CPU perl-Sys-MemInfo perl-Net-DNS perl-Proc-ProcessTable perl-Email-Valid perl-Net-SMTPS perl-Mail-IMAPClient perl-LDAP perl-JSON perl-libwww-perl perl-Text-QRCode perl-Net-SSH2 perl-Net-Ping perl-CPAN wget
	sudo cpan Proc::Background
else ifeq ($(ARCH),Darwin)
	@echo "NOTE: This system-type is not properly supported"
	brew install apache2 qemu perl python3 python-setuptools grep wget gnu-sed nano
	# install PERL CPAN modules
	# WARNING: Net::SMTPS fails installation on Mac
	PERL_MM_OPT="INSTALL_BASE=$(PERLDIR)/lib/perl5/site_perl" cpan CGI Cwd File::Temp File::Path File::Basename File::Copy List::MoreUtils
	PERL_MM_OPT="INSTALL_BASE=$(PERLDIR)/lib/perl5/site_perl" cpan List::Util IO::Socket::INET IO::Socket::IP JSON Proc::Background
	PERL_MM_OPT="INSTALL_BASE=$(PERLDIR)/lib/perl5/site_perl" cpan Proc::ProcessTable Proc::Killfam System::CPU Sys::MemInfo Email::Valid
	PERL_MM_OPT="INSTALL_BASE=$(PERLDIR)/lib/perl5/site_perl" cpan Mail::IMAPClient LWP::UserAgent Net::Ping Net::LDAP Net::SSH2 URI
	# install websockify
	$(cd /tmp; wget https://github.com/novnc/websockify/archive/refs/tags/v0.13.0.tar.gz; tar xzf v0.13.0.tar.gz; cd websockify-0.13.0; python3 setup.py build; python3 setup.py build; )
	# install novnc
	if [ ! -d "$(DESTDIR)/share/novnc" ]; then bash -c "cd /tmp; wget https://github.com/novnc/noVNC/archive/refs/tags/v1.6.0.tar.gz; tar xzf v1.6.0.tar.gz; cp -r noVNC-1.6.0 $(DESTDIR)/share/novnc"; fi
endif
	@echo "[OK] Dependencies installed for $(ARCH)"
	@echo "You may now proceed with: make install"

# ------------------------------------------------------------------------------
# install

install: copy config

copy:
	@echo "Installing QWD files for $(ARCH)-type system"
ifeq ($(ARCH),Darwin)
	# create directories (install command is broken - we use mkdir/cp)
	mkdir -p                            $(DESTDIR)$(prefix)/etc/qemu-web-desktop
	mkdir -p                            $(DESTDIR)$(prefix)/etc/qemu-web-desktop/config.d
	mkdir -p                            $(DESTDIR)$(prefix)/bin
	mkdir -p                            $(DESTDIR)$(prefix)/usr/share/qemu-web-desktop/html/desktop
	mkdir -p                            $(DESTDIR)$(prefix)/usr/share/qemu-web-desktop/html/desktop/images
	mkdir -p                            $(DESTDIR)$(prefix)/usr/share/doc/qemu-web-desktop
	mkdir -p                            $(DESTDIR)$(prefix)/var/lib/qemu-web-desktop/machines
	mkdir -p                            $(DESTDIR)$(prefix)/var/lib/qemu-web-desktop/snapshots
	# common install
	cp         etc/machines.conf        $(DESTDIR)$(prefix)/etc/qemu-web-desktop/
	cp         etc/config.pl            $(DESTDIR)$(prefix)/etc/qemu-web-desktop/
	cp         html/desktop/index.html  $(DESTDIR)$(prefix)/usr/share/qemu-web-desktop/html/desktop
	cp         html/desktop/style.css   $(DESTDIR)$(prefix)/usr/share/qemu-web-desktop/html/desktop
	cp         html/desktop/images/*    $(DESTDIR)$(prefix)/usr/share/qemu-web-desktop/html/desktop/images
	# cp         doc/qwdctl.1             $(DESTDIR)$(prefix)/usr/share/man/man1/qwdctl.1
	cp         doc/*.pdf                $(DESTDIR)$(prefix)/usr/share/doc/qemu-web-desktop
	cp         bin/qwdctl               $(DESTDIR)$(prefix)/bin/
	-cp         html/desktop/machines/*  $(DESTDIR)$(prefix)/var/lib/qemu-web-desktop/machines
	# system specific locations
	mkdir -p                            $(DESTDIR)$(prefix)$(DIR_WWW)
	# mkdir -p                            $(DESTDIR)$(prefix)$(DIR_APACHE_CONF_QWD)
	# cp etc/apache.conf                  $(DESTDIR)$(prefix)$(DIR_APACHE_CONF_QWD)/qemu-web-desktop.conf
	mkdir -p                            $(DESTDIR)$(prefix)$(DIR_CGI_BIN)
	cp cgi-bin/qemu-web-desktop.pl      $(DESTDIR)$(prefix)$(DIR_CGI_BIN)/qemu-web-desktop.pl
else
	# create directories
	install -D -d                       $(DESTDIR)$(prefix)/etc/qemu-web-desktop
	install -D -d                       $(DESTDIR)$(prefix)/usr/bin
	install -D -d                       $(DESTDIR)$(prefix)/usr/share/qemu-web-desktop/html/desktop
	install -D -d                       $(DESTDIR)$(prefix)/usr/share/qemu-web-desktop/html/desktop/images
	install -D -d                       $(DESTDIR)$(prefix)/usr/share/doc/qemu-web-desktop
	install -D -d                       $(DESTDIR)$(prefix)/var/lib/qemu-web-desktop/machines
	install -D -d                       $(DESTDIR)$(prefix)/var/lib/qemu-web-desktop/snapshots
	# common install
	install -D etc/machines.conf       -m 644 $(DESTDIR)$(prefix)/etc/qemu-web-desktop/
	install -D etc/config.pl           -m 644 $(DESTDIR)$(prefix)/etc/qemu-web-desktop/
	install -D html/desktop/index.html -m 644 $(DESTDIR)$(prefix)/usr/share/qemu-web-desktop/html/desktop
	install -D html/desktop/style.css  -m 644 $(DESTDIR)$(prefix)/usr/share/qemu-web-desktop/html/desktop
	install -D html/desktop/images/*   -m 644 $(DESTDIR)$(prefix)/usr/share/qemu-web-desktop/html/desktop/images
	install -D doc/qwdctl.1            -m 644 $(DESTDIR)$(prefix)/usr/share/man/man1/qwdctl.1
	install -D doc/README.pdf          -m 644 $(DESTDIR)$(prefix)/usr/share/doc/qemu-web-desktop
	install -D bin/qwdctl               $(DESTDIR)$(prefix)/usr/bin/
	-install -D html/desktop/machines/* -m 644 $(DESTDIR)$(prefix)/var/lib/qemu-web-desktop/machines
	# system specific locations
ifndef DEB_BUILD_ARCH
	install -D -d                       $(DESTDIR)$(prefix)$(DIR_WWW)
endif
	install -D -d                       $(DESTDIR)$(prefix)$(DIR_APACHE_CONF_QWD)
	install etc/apache.conf      -m 644 $(DESTDIR)$(prefix)$(DIR_APACHE_CONF_QWD)/qemu-web-desktop.conf
	install -D -d                       $(DESTDIR)$(prefix)$(DIR_CGI_BIN)
	install -D cgi-bin/qemu-web-desktop.pl $(DESTDIR)$(prefix)$(DIR_CGI_BIN)/qemu-web-desktop.pl
	# system specific actions
ifneq ($(ARCH),Debian)
	sed -i 's|Alias /qemu-web-desktop|#Alias /qemu-web-desktop|'  $(DESTDIR)$(prefix)$(DIR_APACHE_CONF_QWD)/qemu-web-desktop.conf
	sed -i 's/config{service_port_multiple}    = 0/config{service_port_multiple}    = 1/' $(DESTDIR)$(prefix)/etc/qemu-web-desktop//config.pl
	sed -i 's/machines_insert=no/machines_insert=yes/'            $(DESTDIR)$(prefix)/usr/bin/qwdctl
endif
endif
	-mv $(DESTDIR)$(prefix)/usr/share/qemu-web-desktop/html/desktop/machines/* $(DESTDIR)$(prefix)/var/lib/qemu-web-desktop/machines/
	chmod a+wxr                         $(DESTDIR)$(prefix)/var/lib/qemu-web-desktop
	chmod a+xrw                         $(DESTDIR)$(prefix)/var/lib/qemu-web-desktop/machines
	chmod u+xrw                         $(DESTDIR)$(prefix)/var/lib/qemu-web-desktop/snapshots
	find                                $(DESTDIR)$(prefix)/usr/share/qemu-web-desktop/html -type f -exec chmod a+r {} +

## qemu-web-desktop 26.02.08+ds1

=== debian/changelog ===
qemu-web-desktop (26.02.08+ds1-1) unstable; urgency=medium

  * New upstream version 26.02.08+ds1
  * d/apache2: use dh_apache2 heuristic mode
  * d/control: Only amd64 and arm64 are supported for now
  * d/control: use dh-sequence-installsysusers
  * d/control: Fix my email
  * d/copyright: fix Files-Excluded with the new upstream organisation
  * d/manpages: The make file take care of this
  * d/rules: simplify now that the make file is doing everythongs for us
  * d/rules: skip test for now

 -- Picca Frédéric-Emmanuel <picca@debian.org>  Sun, 08 Feb 2026 15:51:31 +0100

=== debian/control ===
Source: qemu-web-desktop
Section: science
Priority: optional
Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Roland Mas <lolando@debian.org>,
           Emmanuel Farhi <emmanuel.farhi.1@gmail.com>,
           Picca Frédéric-Emmanuel <picca@debian.org>
Build-Depends: debhelper-compat (= 13),
               dh-sequence-apache2,
               dh-sequence-installsysusers,
Standards-Version: 4.1.2
Vcs-Browser: https://salsa.debian.org/debian/qemu-web-desktop
Vcs-Git: https://salsa.debian.org/debian/qemu-web-desktop.git
Homepage: https://gitlab.com/soleil-data-treatment/soleil-software-projects/remote-desktop

Package: qemu-web-desktop
Architecture: amd64 arm64
Depends: bridge-utils,
         confget | crudini,
         dnsmasq,
         guestfs-tools,
         iptables,
         libapache2-mod-perl2,
         libapache2-mpm-itk,
         libcgi-pm-perl,
         libemail-valid-perl,
         libjson-perl,
         liblist-moreutils-perl,
         libmail-imapclient-perl,
         libnet-dns-perl,
         libnet-ldap-perl,
         libnet-smtps-perl,
         libnet-ssh2-perl,
         libproc-background-perl,
         libproc-processtable-perl,
         libsys-cpu-perl,
         libsys-cpuload-perl,
         libsys-meminfo-perl,
         libtext-qrcode-perl,
         novnc,
         qemu-system-arm [arm64],
         qemu-system-x86 [amd64],
         websockify,
         wget,
         ${misc:Depends},
         ${shlibs:Depends},
Recommends: ${misc:Recommends}
Suggests: qemu-system
Description: Remote desktop service with virtual machines in a browser (DARTS).
 A remote desktop service that launches virtual machines and displays
 them in your browser. Place virtual machine files (ISO, QCOW2, VDI,
 VMDK...) into /var/lib/qemu-web-desktop/machines, add their names in
 the /etc/qemu-web-desktop/machines.conf file (use: qwdctl edit machines),
 and run: qwdctl refresh.
 You can tune the service settings in the
 /etc/qemu-web-desktop/config.pl (use: qwdctl edit config).
 This project is also named Data Analysis Remote Treatment Service (DARTS).
 .
 Once installed, connect to http://server/qemu-web-desktop

=== debian/rules ===
#!/usr/bin/make -f

%:
	dh $@

# to remove once upstream fix the Makefile
override_dh_auto_clean:
	rm -rf html/desktop/machines
	dh_auto_clean

# to remove once upstream fix the Makefile
override_dh_auto_build:
	mkdir -p html/desktop/machines
	touch html/desktop/machines/README
	dh_auto_build

#override_dh_auto_build:
#	mkdir -p build/etc
#	cp etc/apache.conf build/etc/qemu-web-desktop.conf

override_dh_auto_test:

## qemu-web-desktop 26.03.02+ds1

=== debian/changelog ===
qemu-web-desktop (26.03.02+ds1-1) unstable; urgency=medium

  [ Emmanuel FARHI ]
  * New upstream version 26.03.02+ds1

 -- Emmanuel Farhi <emmanuel.farhi.1@gmail.com>  Mon, 02 Mar 2026 11:28:09 +0100

qemu-web-desktop (26.02.08+ds1-2) unstable; urgency=medium

  * d/postinst: remove useless call to apache2-maintscript-helper

 -- Picca Frédéric-Emmanuel <picca@debian.org>  Sun, 08 Feb 2026 17:11:15 +0100

## qemu-web-desktop 26.03.03+ds1

=== debian/changelog ===
qemu-web-desktop (26.03.03+ds1-1) unstable; urgency=medium

  [ Emmanuel FARHI ]
  * New upstream version 26.03.03+ds1
  * fix reverse proxy (apache/websockify)

 -- Emmanuel Farhi <emmanuel.farhi.1@gmail.com>  Tue, 03 Mar 2026 08:49:38 +0100
